/*
 * bb.c 
 * BIG BROTHER CLIENT PROGRAM
 * Sean MacGuire - The MacLawran Group Inc.
 * Version 1.06
 * Dec 30, 1997
 *
 * This program is Copyright (c) 1997 
 * The MacLawran Group Inc.
 * All Rights Reserved
 *
 * SENDS THE INPUT LINE TO THE DAEMON ON THE BIG BROTHER PORT
 * Format: bb <LINE>
 *
 *	LINE:		<IP-ADDR> <page|status> <DATA>
 *	IP-ADDR:	IP-ADDR OF THE SERVER
 *	DATA:		for page:	<TEL-NO> <NUMERIC MESSAGE>
 *			for status:	<machine><color-code><status-msg>
 */

#include "bb.h"		/* THE BIG BROTHER INCLUDE FILE */

jmp_buf env;  

main(argc, argv)
int argc;
char *argv[];
{
	if (argc != 3) {
		fprintf(stderr, "bb: incorrect number of arguments\n");
		fprintf(stderr, "Format: <IP-ADDR> <DATA>\n");
		exit(1);
	}
	bbnotify(argv[1], argv[2]);	/* SEND IT ACROSS */
	exit(0);
}

bbnotify(ip,data)
char *ip;				/* IP ADDRESS */
char *data;				/* DATA TO SEND ACROSS */
{
  char *bbpage = NULL;
  char v1[16],v2[128],v3[16],v4[16];

  debug("Sending: ** %s ** to %s\n",data,ip);
  bbsend(ip, data);	/* SEND IT ACROSS */

  /* If BBPAGE is defined then send also a msg if it's a red alert */
  /* What if BBPAGE == BBDISP ? for now send two messages */
  /* keep it simple ... */
  bbpage = (char *) getenv("BBPAGE");
  if( bbpage != NULL ) {
    /* %*s could have been used for v2 but */
    /* Linux thought otherwise i.e. bug or I misunderstood the %*s (skip) */
    sscanf(data,"%15s %127s %16s %*s",v1,v2,v3,v4);
    if( !strcmp(v1,"status") && !strcmp(v3,"red") ) {
      memcpy(data,"page  ",6); /* Change msg type */
      debug("Sending: ** %s ** to %s\n",data,bbpage);
      bbsend(bbpage,data);	/* SEND IT ACROSS TO BBPAGER */
    }
  }
}

bbsend(ip, data)
char *ip;				/* IP ADDRESS */
char *data;				/* DATA TO SEND ACROSS */
{
 	int n, sockfd, newsockfd, child, port, len, timeout();
        struct sockaddr_in serv_addr, cli_addr;
	static char line[MAXLINE];

	port=PORT;			/* DEFAULT PORT */

        debug("MAKING SOCKET CONNECTION...\n");
        if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
                fprintf(stderr, "Can't open stream socket");
		exit(1);
        }
        debug("SOCKET CONNECTED OK...\n");

        bzero((char *) &serv_addr, sizeof(serv_addr));
        serv_addr.sin_family = AF_INET;
        serv_addr.sin_addr.s_addr = inet_addr(ip);
        serv_addr.sin_port = htons(port);

	/*
	 * THIS IS A LITTLE NASTY
	 * IF THE SERVER'S NOT UP, THIS WILL WAIT A LONG TIME BEFORE
	 * IT TIMES OUT.  SO HANDLE THAT HERE... IT GETS 3 SECONDS TO ANSWER
	 */
 	if (setjmp(env) != 0) {
                debug("CALLING SETJMP\n");
        }
        signal(SIGALRM, (void *)timeout);
        alarm(3);

        /* OPEN SOCKET */
        if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
                fprintf(stderr, "\nbb: CAN'T BIND TO SOCKET");
        }
        if (connect(sockfd, (struct sockaddr *) &serv_addr,
                        sizeof(serv_addr)) < 0) {
                fprintf(stderr, "\nbb: CAN'T CONNECT TO bbd");
        }
        n = send(sockfd, data, strlen(data) + 1, 0);
	close(sockfd);
	alarm(0);	/* Previous alarm not needed anymore */
	return(n);
}

timeout()
{
	fprintf(stderr, "bb: CONNECTION TIMED OUT...");
	exit(2);
}
